package entropia;

import java.util.*;

public class Rozmieszczenie8_4_2{
	public static String[] urny = {"A", "A", "B", "C", "D", "E", "F", "G"};
	public static int[] kule = {1, 1, 2, 3, 4, 5, 6, 7};

	public static void main(String[] args) {
		int liczbaPowt = 2700000;
		int n = 3;//liczba kul
		boolean ko = false;//kule odróżnialne?
		int k = 3;//liczba urn
		boolean uo = false;//urny odróżnialne?
		int nr = rows(k, uo, n, ko);
		System.out.println(nr);
		FrequencyMap<String> map = new FrequencyMap<String>();
		if(ko && uo){
			while(map.getSize() != nr){
				for(int j = 0; j < liczbaPowt; j++){
					int[] kule = fillN(n);
					String[] urny = fillL(k);
					for(int i = 0; i < kule.length; i++){
						int r = randomInRange(0, k - 1);
						urny[r] = urny[r].concat(String.valueOf(kule[i]));
					}
					map.add(Arrays.toString(urny));
				}
			}
			map.printAll();
		}
		else if(!ko && uo){
			while(map.getSize() != nr){
				for(int j = 0; j < liczbaPowt; j++){
					int[] kule = new int[n];
					Arrays.fill(kule, 1);
					String[] urny = fillL(k);
					for(int i = 0; i < kule.length; i++){
						int r = randomInRange(0, k - 1);
						urny[r] = urny[r].concat(String.valueOf(kule[i]));
					}
					map.add(Arrays.toString(urny));
				}
			}
			map.printAll();
		}
		else if(ko && !uo){
			while(map.getSize() != nr){
				for(int j = 0; j < liczbaPowt; j++){
					int[] kule = fillN(n);
					String[] urny = new String[k];
					Arrays.fill(urny, "A");
					for(int i = 0; i < kule.length; i++){
						int r = randomInRange(0, k - 1);
						urny[r] = urny[r].concat(String.valueOf(kule[i]));
					}
					Arrays.sort(urny);
					map.add(Arrays.toString(urny));
				}
			}
			map.printAll();
		}
		else if(!ko && !uo){
			while(map.getSize() != nr){
				for(int j = 0; j < liczbaPowt; j++){
					int[] kule = new int[n];
					Arrays.fill(kule, 1);
					String[] urny = new String[k];
					Arrays.fill(urny, "A");
					for(int i = 0; i < kule.length; i++){
						int r = randomInRange(0, k - 1);
						urny[r] = urny[r].concat(String.valueOf(kule[i]));
					}
					Arrays.sort(urny);
					map.add(Arrays.toString(urny));
				}
			}
			map.printAll();
		}
	}

	public static int[] fillN(int number) {
		int[] tabl = new int[number];
		for(int i = 0; i < tabl.length; i++){
			tabl[i] = kule[i + 1];
		}
		return tabl;
	}

	public static String[] fillL(int number) {
		String[] tabl = new String[number];
		for(int i = 0; i < tabl.length; i++){
			tabl[i] = urny[i + 1];
		}
		return tabl;
	}

	public static int rows(int k, boolean uo, int n, boolean ko) {
		if(ko && uo){
			return r111(k, n);
		}
		else if(ko && !uo){
			return r101(k, n);
		}
		else if(!ko && uo){
			return r011(k, n);
		}
		else if(!ko && !uo){
			return r001(k, n);
		}
		return -1;
	}

	public static int r001(int k, int n) {
		int sum = 0;
		for(int i = 1; i < k + 1; i++){
			sum += r000(i, n);
		}
		return sum;
	};

	public static int r000(int k, int n) {
		if(n == 0 || k == 0){
			return 0;
		}
		else if(n > 0){
			if(k == 1){
				return 1;
			}
			else if(n < k){
				return 0;
			}
			else if(n == k){
				return 1;
			}
			else{
				return r000(k - 1, n - 1) + r000(k, n - k);
			}
		}
		return -1;
	};

	public static int randomInRange(int min, int max) {
		int random = -1;
		if(min > max){
			System.out.println("pierwsza liczba musi byc mniejsza od drugiej");
		}
		else{
			random = (int)(Math.floor(Math.random() * (max - min + 1)) + min);
		}
		return random;
	}

	public static int r111(int k, int n) {
		return (int)Math.pow(k, n);
	};

	public static int r011(int k, int n) {
		return (int)npok(n + k - 1, n);
	};

	public static int r101(int k, int n) {
		int sum = 0;
		for(int i = 1; i < k + 1; i++){
			sum += recurStir2(i, n);
		}
		return sum;
	};

	public static int recurStir2(int k, int n) {
		if(n == 0 && k == 0){
			return 1;
		}
		else if(n == 0 && k == 1){
			return 0;
		}
		else if(n > 0){
			if(k == 0){
				return 0;
			}
			else if(k == 1){
				return 1;
			}
			else if(n < k){
				return 0;
			}
			else if(n == k){
				return 1;
			}
			else{
				return recurStir2(k - 1, n - 1) + k * recurStir2(k, n - 1);
			}
		}
		return -1;
	};

	public static long npok(int n, int k) {
		if(k > n){
			return 0;
		}
		else if(k == 0 || k == n){
			return 1;
		}
		else if(k == 1 || k == (n - 1)){
			return n;
		}
		else{
			long b = factorial(k);
			long c = factorial(n - k);
			long a = b;
			for(long i = k + 1; i < n + 1; i++){
				a *= i;
			}
			return a / (b * c);
		}
	}

	public static long factorial(int n) {
		if(n == 0){
			return 1;
		}
		long sum = 1;
		for(int i = 1; i < n + 1; i++){
			sum *= i;
		}
		return sum;
	};

	/**
	 * Tworzy tablice intów od ... do ... włacznie
	 * @param n1 int - dolna granica
	 * @param n2 int - górna granica
	 * @return int[] zwraca tablicę intów od n1 do n2 włącznie
	 */
	public static int[] rangeArray(int n1, int n2) {
		int[] table = new int[n2 - n1 + 1];
		for(int i = 0; i < table.length; i++){
			table[i] = n1 + i;
		}
		return table;
	}
}
